#include "vdu.h";
#include "vdu_Y_Cb_Cr.h"
extern vdubuf *vdu, vdu0, vdu1;
extern unsigned  width,height,wH,rowsize;
char hexbuf[11];
char *hex8( int x)
{  int i,j,k;
	for (i=0; i<8; i++)	{ 
		j=x & 15;
		k=(j>9)? j+=87 : j+=48;
		hexbuf[7-i]=(char)k;
		x>>=4;
	}
	hexbuf[8]=0;
	return hexbuf;
}

unsigned round( double x)
{ if (x<0.0) return (unsigned)(x-0.4999999999);  else
	return (unsigned)(x+0.4999999999);
}

int YCbCr( int R, int G, int B) // def by JPEG
{ double Y,Cb,Cr; int z,cr,cb,y; 
//     0..255
Y=0.299*R + 0.587*G + 0.114*B;
Cb=128 - 0.168736*R - 0.331264*G + 0.5*B;
Cr=128 + 0.5*R - 0.418688*G - 0.081312*B;
y=round(Y); cb=round(Cb); cr=round(Cr);	
z=(y<<16)+(cb<<8) + cr;
return (unsigned)z;	
}
int RGB( int Y, int Cb, int Cr) // def by JPEG
{ int z,R,G,B,cr,cb;
  cr=Cr-128; cb=Cb-128;
  R=round(Y+1.402*cr);
  G=round(Y-0.34414*cb-0.71414*cr);
  B=round(Y+1.772*cb);
  z=(((R<<8)+G)<<8)+B; return z;	
} // RGB
void Ellipse ( int x0, int y0, int a, int b, int color)
{ int x, aq,bq, dx,dy, sgm,rx,ry;
  unsigned *j1,*j2;
  x = a;
  j2=vdu->crt + (x0>>2) + rowsize*y0;    j1=j2;
  aq = a * a;
  bq = b * b;
  dx = aq << 1;  //            dx = 2 * a * a
  dy = bq << 1;  //            dy = 2 * b * b
  sgm  = a * bq; //            r  = a * b * b
  rx = sgm << 1; //            rx = 2 * a * b * b
  ry = 0;        //            because y = 0
  while (x > 0)
  {
      if (sgm > 0)   //   y++
    {
      j1+=rowsize;     j2-=rowsize;
      ry+=dx;            //ry = dx * y
      sgm-=ry;           //r = r - dx + y
    }
       if ( sgm <= 0)    // x--
    {
      x--;
      rx-=dy;        // rx = dy * x
      sgm+=rx;       // r = r + dy * x
    }
      j1[x]=  color;
      j1[-x]= color;
      j2[x]=  color;
      j2[-x]= color;
  }
} // Ellipse
void fill( unsigned *dst, int l, int color)
{  unsigned *p, *q;
   for (p=dst,q=p+l; p<q; ) *p++=color;
}
void fillBG()
{ unsigned i,j,wH;
   wH=width*height;
   i=wH>>3;  j=wH>>2;
   fill( vdu0.crt, j, 0x10101010);	
   fill( vdu0.Cb,  i, 0x80808080);
   fill( vdu1.crt, j, 0x10101010);	
   fill( vdu1.Cb,  i, 0x80808080);
}
void verl_Y( int x, int y, int L, int grey)//     Y
{  unsigned m, k, i, j,*Y, cy;
   k=rowsize*y + (x>>2);  i=(x & 3)<<3;    
   cy=(grey & 255)<<i; m=~(255 << i);
	
   Y=vdu->crt+k;
   for (j=0; j<L; j++)
   { *Y=(*Y & m) | cy;
//msg(hex8(cy));
     Y+=rowsize;
   }
} // verl_Y
void verl_cbcr( int x, int y, int L, int CbCr)//     CbCr
{ unsigned kc,i,msk,cb,cr,*qb,*qr,dptr;
   dptr=rowsize;
   kc=(rowsize>>1)*(y>>1) + (x>>3); 
	qb=vdu->Cb+kc;
	qr=vdu->Cr+kc;
   cb=(CbCr>>8)&255;   cr=CbCr&255;
   i=(x&3)<<3; msk=~(255<<i);
    cb=cb<<i;  cr=cr<<i;	
   for (i=0; i<L; i++)
   {  *qb=( *qb & msk ) | cb;
      *qr=( *qr & msk ) | cr;
      qb+=dptr>>1;qr+=dptr>>1;	   
   }
} // verl_cbcr
unsigned pxl( int x, int y, int color) // color=YCbCr
{ static unsigned msk[4]={0xffffff00, 0xffff00ff, 0xff00ffff, 0xffffff};
   unsigned m, k, i, jb,jr, n, Y, cb, cr;
   m=rowsize*y;  k=m + (x>>2);  i=x & 3;
   n=((x>>1)&3)<<3;
   Y=color>>16;cb=((color>>8)&255)<<n;cr=(color&255)<<n;
   vdu->crt[k]=(vdu->crt[k] & msk[i]) | (Y << (i<<3));
   n=n>>3;
   m=(rowsize>>1)*(y>>1);
   i=m+(x>>3);	
   jb=(vdu->Cb[i] & msk[n])|cb;   vdu->Cb[i]=jb; //  
   jr=(vdu->Cr[i] & msk[n])|cr;   vdu->Cr[i]=jr; //     
//msg2( jb, jr);
   return m;
} // pxl

void fillrect( int x0, int y0, int Nx, int Ny, unsigned color)
// color=YCbCr
{ int i,j;
    for (i=y0,j=i+Ny; i<j; i++)
    { horl ( x0, i, Nx, color);
    }	    
}
